Subject: "tail" option for backward_word()

  NEdit*text.translations: #override \
    Alt Shift Ctrl<KeyPress>osfLeft: backward_word("extend", "tail")\n\
    Meta Shift Ctrl<KeyPress>osfLeft: backward_word("extend", "tail")\n\
    Alt Ctrl<KeyPress>osfLeft: backward_word("tail")\n\
    Meta Ctrl<KeyPress>osfLeft: backward_word("tail")\n\
    Alt Shift Ctrl<KeyPress>osfRight: forward_word("extend", "tail")\n\
    Meta Shift Ctrl<KeyPress>osfRight: forward_word("extend", "tail")\n\
    Alt Ctrl<KeyPress>osfRight: forward_word("tail")\n\
    Meta Ctrl<KeyPress>osfRight: forward_word("tail")\n\
    ...

---

 doc/help.etx  |    5 +++--
 source/text.c |   21 +++++++++++++++++----
 2 files changed, 20 insertions(+), 6 deletions(-)

diff --quilt old/source/text.c new/source/text.c
--- old/source/text.c
+++ new/source/text.c
@@ -2691,11 +2691,24 @@ static void backwardWordAP(Widget w, XEv
         ringIfNecessary(silent, w);
     	return;
     }
+
     pos = max(insertPos - 1, 0);
-    while (strchr(delimiters, BufGetCharacter(buf, pos)) != NULL && pos > 0)
-    	pos--;
-    pos = startOfWord((TextWidget)w, pos);
-    	
+    if (hasKey("tail", args, nArgs)) {
+        pos = max(startOfWord((TextWidget)w, pos) - 1, 0);
+        while (pos > 0) {
+            if (strchr(delimiters, BufGetCharacter(buf, pos)) == NULL)
+                break;
+            pos--;
+        }
+        if (pos)
+            pos++;
+    }
+    else {
+        while (strchr(delimiters, BufGetCharacter(buf, pos)) != NULL && pos > 0)
+            pos--;
+        pos = startOfWord((TextWidget)w, pos);
+    }
+
     TextDSetInsertPosition(textD, pos);
     checkMoveSelectionChange(w, event, insertPos, args, nArgs);
     checkAutoShowInsertPos(w);
diff --quilt old/doc/help.etx new/doc/help.etx
--- old/doc/help.etx
+++ new/doc/help.etx
@@ -3312,11 +3312,12 @@ Action Routines
   the beginning of the previous paragraph.  Paragraphs are defined as regions
   of text delimited by one or more blank lines.
 
-**backward_word( ["nobell"] )**
+**backward_word( ["tail"] ["nobell"] )**
   Moves the cursor to the beginning of a word, or, if the
   cursor is already at the beginning of a word, moves the cursor to the
   beginning of the previous word.  Word delimiters are user-settable, and
-  defined by the X resource wordDelimiters.
+  defined by the X resource wordDelimiters. If the "tail" argument is supplied
+  the cursor is moved to the end of the next previous word.
 
 **beginning_of_file( ["scrollbar"] )**
   Moves the cursor to the beginning of the file.
